# FastyBird IoT devices module

[![Build Status](https://badgen.net/github/checks/FastyBird/devices-module/master?cache=300&style=flast-square)](https://github.com/FastyBird/devices-module/actions)
[![Code coverage](https://badgen.net/coveralls/c/github/FastyBird/devices-module?cache=300&style=flast-square)](https://coveralls.io/r/FastyBird/devices-module)
![PHP](https://badgen.net/packagist/php/FastyBird/devices-module?cache=300&style=flast-square)
[![Licence](https://badgen.net/packagist/license/FastyBird/devices-module?cache=300&style=flast-square)](https://packagist.org/packages/FastyBird/devices-module)
[![Downloads total](https://badgen.net/packagist/dt/FastyBird/devices-module?cache=300&style=flast-square)](https://packagist.org/packages/FastyBird/devices-module)
[![Latest stable](https://badgen.net/packagist/v/FastyBird/devices-module/latest?cache=300&style=flast-square)](https://packagist.org/packages/FastyBird/devices-module)
[![PHPStan](https://img.shields.io/badge/PHPStan-enabled-brightgreen.svg?style=flat-square)](https://github.com/phpstan/phpstan)

[![Latest stable](https://badgen.net/npm/v/@fastybird/devices-module?cache=300&style=flast-square)](https://www.npmjs.com/package/@fastybird/devices-module)
[![Downloads total](https://badgen.net/npm/dt/@fastybird/devices-module?cache=300&style=flast-square)](https://www.npmjs.com/package/@fastybird/devices-module)
![Types](https://badgen.net/npm/types/@fastybird/devices-module?cache=300&style=flast-square)

![Python](https://badgen.net/pypi/python/fastybird-devices-module?cache=300&style=flat-square)
[![Licence](https://badgen.net/pypi/license/fastybird-devices-module?cache=300&style=flast-square)](https://github.com/FastyBird/devices-module/blob/master/LICENSE.md)
[![Latest stable](https://badgen.net/pypi/v/fastybird-devices-module?cache=300&style=flast-square)](https://pypi.org/project/fastybird-devices-module/)
[![Black](https://img.shields.io/badge/Black-enabled-brightgreen.svg?style=flat-square)](https://github.com/psf/black)

## What is FastyBird IoT devices module?

Devices module is a combined [Nette framework](https://nette.org) extension and [Vex ORM](https://vuex-orm.org) plugin for managing connected devices and their basic logic.

[FastyBird](https://www.fastybird.com) [IoT](https://en.wikipedia.org/wiki/Internet_of_things) devices module is an [Apache2 licensed](http://www.apache.org/licenses/LICENSE-2.0) distributed extension, developed in [PHP](https://www.php.net) with [Nette framework](https://nette.org) and in [Typescript](https://www.typescriptlang.org).

### Features:

- Devices and channels management
- Support for data exchange
- [{JSON:API}](https://jsonapi.org/) schemas for full api access
- User access check & validation
- Multilingual
- JS integration via [Vuex ORM](https://vuex-orm.org) plugin
- Python integration via [PonyORM](https://ponyorm.org)

## Requirements

Backend part of [FastyBird](https://www.fastybird.com) devices module is tested against PHP 7.4 and [ReactPHP http](https://github.com/reactphp/http) 0.8 event-driven, streaming plaintext HTTP server and [Nette framework](https://nette.org/en/) 3.0 PHP framework for real programmers

Frontend part of [FastyBird](https://www.fastybird.com) devices module is tested against [ECMAScript 6](https://www.w3schools.com/JS/js_es6.asp)

Python part of [FastyBird](https://www.fastybird.com) devices module is tested against [Python 3.7](http://python.org)

## Installation

#### Backend

The best way to install **fastybird/devices-module** is using [Composer](http://getcomposer.org/):

```sh
composer require fastybird/devices-module
```

#### Frontend

The best way to install **@fastybird/devices-module** is using [Yarn](https://yarnpkg.com/):

```sh
yarn add @fastybird/devices-module
```

or if you prefer npm:

```sh
npm install @fastybird/devices-module
```

#### Python project:

The best way to install **fastybird-devices-module** is using [pip](https://pip.pypa.io/):

```sh
pip install fastybird-devices-module
```

## Documentation

Learn how to use devices module and manage your devices in [documentation](https://github.com/FastyBird/devices-module/blob/master/.docs/en/index.md).

## Feedback

Use the [issue tracker](https://github.com/FastyBird/devices-module/issues) for bugs or [mail](mailto:code@fastybird.com) or [Tweet](https://twitter.com/fastybird) us for any idea that can improve the project.

Thank you for testing, reporting and contributing.

## Changelog

For release info check [release page](https://github.com/FastyBird/devices-module/releases)

## Maintainers

<table>
	<tbody>
		<tr>
			<td align="center">
				<a href="https://github.com/akadlec">
					<img width="80" height="80" src="https://avatars3.githubusercontent.com/u/1866672?s=460&amp;v=4">
				</a>
				<br>
				<a href="https://github.com/akadlec">Adam Kadlec</a>
			</td>
		</tr>
	</tbody>
</table>

***
Homepage [https://www.fastybird.com](https://www.fastybird.com) and repository [https://github.com/fastybird/devices-module](https://github.com/fastybird/devices-module).
